function SortData(TbodyId, Index, CmpFunc, GetFunc, SortTypeId, SortType) {
	var Value = new Array;
	var TbodyObject = document.getElementById(TbodyId);
	var Rows = TbodyObject.rows;
	var Number = Rows.length;
	var TbodyNew = document.createElement("tbody");
	if (SortTypeId) {
		document.getElementById(SortTypeId).innerHTML = SortType;
	}
	CmpFunc = CmpFunc || arguments.callee.compareFunc;
	GetFunc = GetFunc || arguments.callee.getFunc || function(Cell){return Cell.nodeName;};
	for (var i = 0; i < Number; i++) {
		Value[i] = Object(GetFunc(Rows[i].cells[Index], Rows[i].cells[0]));
		Value[i].row = Rows[i];
	}
	if (CmpFunc) {
		Value.sort(CmpFunc);
	}
	else {
		Value.sort();
	}
	TbodyObject.parentNode.replaceChild(TbodyNew, TbodyObject);
	for (var i = 0; i < Number; i++) {
		TbodyObject.appendChild(Value[i].row);
	}
	TbodyNew.parentNode.replaceChild(TbodyObject, TbodyNew);
}
function GetDataFunc1(Cell) {
	return eval(Cell.firstChild.nodeValue);
}
function GetDataFunc2(Cell1, Cell2) {
	return ((Cell1.firstChild.nodeValue == "--") ? 0 : eval(Cell1.firstChild.nodeValue) * 10000) + 10000 - eval(Cell2.firstChild.nodeValue);
}
function CompareFunc1(Value1, Value2) {
	return (Value1 > Value2) ? -1 : Value1 != Value2;
}
function CompareFunc2(Value1, Value2) {
	return (Value1 < Value2) ? -1 : Value1 != Value2;
}
function GetBytes(Text, Limit) {
	var c;
	var n = 0;
	var Length = Text.length;
	for (var i = 0; i < Length; i++) {
		c = Text.charAt(i);
		if (c >= "" && c <= "") {
			n += 1;
		}
		else if (c == "&") {
			if (Text.charAt(i + 1) == "#" && Text.substring(i + 2, Text.length).match("^(([0-9]+)|([xX][0-9a-fA-F]+));")) {
				n += 1;
			}
			else {
				n += 5;
			}
		}
		else if (c == "<") {
			n += 4;
		}
		else if (c == ">") {
			n += 4;
		}
		else if (c == "\"") {
			n += 5;
		}
		else if (c == "'") {
			n += 5;
		}
		else if (c == "\r") {
			n += 5;
			if (Text.charAt(i + 1) == "\n") i++;
		}
		else if (c == "\n") {
			n += 5;
		}
		else if (escape(c).length > 3) {
			n += 2;
		}
		else {
			n += 1;
		}
		if (n >= Limit) {
			n = Limit;
			break;
		}
	}
	return n;
}
function Counter(Text1, Text2, Type) {
	if (Type == 0) {
		Text2.value = GetBytes(Text1.value, 999);
	}
	else if (Type == 1) {
		Text2.value = parseInt((GetBytes(Text1.value, 1998) + 1) / 2);
	}
	else {
		Text2.value = parseInt((GetBytes(Text1.value, 3998) + 1) / 2);
	}
}
function ChangeRow(TableId, Rows) {
	var Tbody = document.getElementById(TableId).tBodies[0];
	var Length = Tbody.rows.length;
	for (var i = Rows; i < Length; i++) {
		Tbody.rows[i].onmouseover = function(){this.style.backgroundColor="#fcfcf0"};
		Tbody.rows[i].onmouseout = function(){this.style.backgroundColor="#fcfcfc"};
	}
}
function ChangeRow2(TableId) {
	this.table = TableId;
	this.PosRow = this._SetRow();
}
ChangeRow2.prototype.Set = function() {
	var Pos = new Array;
	var Cell;
	var Length = arguments.length;
	for (var i = 1; i < Length; i++) {
		Pos[i - 1] = arguments[i];
	}
	for (var y in this.table.rows) {
		if (y < arguments[0]) continue;
		for (var x in this.table.rows[y].cells) {
			Cell = this.table.rows[y].cells[x];
			if (!Cell.style) continue;
			AddEvent(Cell, 'mouseover', this.coloring(y, x, this.color || '#fcfcf0', Pos));
			AddEvent(Cell, 'mouseout', this.coloring(y, x, '', Pos));
		}
	}
}
ChangeRow2.prototype.coloring = function(y, x, Color, Pos)
{
	var _this = this;
	var CellSpan = new Array;
	var Cell = new Array;
	var Length;
	Length = this.table.rows[y].cells.length;
	for (var i = 0; i < Length; i++) {
		Cell[i] = this.table.rows[y].cells[i];
	}
	return function (e) {
		var Length2 = Pos.length;
		for (var i = 0; i < Length2; i++) {
			CellSpan[Pos[i]] = _this.GetParentRow(y, x, Pos[i]);
			CellSpan[Pos[i]].style.backgroundColor = Color || '';
		}
		for (var i = 0; i < Length; i++) {
			Cell[i].style.backgroundColor = Color || '';
		}
	}
}
ChangeRow2.prototype.GetParentRow = function(y, x, p) {
	var Pos = this._Get(this.PosRow, this.table.rows[y].cells[x].offsetTop);
	return this.table.rows[Pos].cells[p];
}
ChangeRow2.prototype._Get = function(Pos, m) {
	for (var i in Pos) {
		if (Pos[i][1] < m + 5 && m < Pos[i][2]) return Pos[i][0];
	}
	return 0;
}
ChangeRow2.prototype._SetRow = function() {
	var Pos = new Array;
	var Ret = 0;
	var x = 0;
	for (var i in this.table.rows) {
		if (--Ret > 0) continue;
		if (!this.table.rows[i].cells) continue;
		var cell = this.table.rows[i].cells[0];
		Ret = cell.rowSpan;
		Pos[++x] = new Array;
		Pos[x][0] = i;
		Pos[x][1] = cell.offsetTop;
		Pos[x][2] = cell.offsetTop + cell.offsetHeight;
	}
	return Pos;
}
function ChangeRow3(TbodyId) {
	var TbodyObject = document.getElementById(TbodyId);
	var Length = TbodyObject.rows.length;
	for (var i = 0; i < Length; i++) {
		TbodyObject.rows[i].onmouseover = function(){this.style.backgroundColor="#fcfcf0"};
		TbodyObject.rows[i].onmouseout = function(){this.style.backgroundColor="#fcfcfc"};
	}
}
function AddEvent(Obj, EventType, Func) {
	if (Obj.addEventListener) {
		Obj.addEventListener(EventType, Func, false);
	}
	else if (Obj.attachEvent) {
		Obj.attachEvent("on" + EventType, Func);
	}
	else {
		Obj["on" + EventType] = Func;
	}
}
function ChangeItem(Button, Item, IdName, Max, Mode, TypeNo) {
	var ButtonObject, ItemObject, DisplayType, IdNo;
	var Type = 1 << TypeNo;
	var CookieData = GetCookie2("exp");
	if (Mode == 0) {
		if (CookieData == false || (CookieData & Type) == 0) return;
		ButtonObject = document.getElementById(Button);
	}
	else {
		ButtonObject = Button;
		if (CookieData == false) {
			CookieData = (ButtonObject.value == Item + "\Ȃ") ? Type : 0;
		}
		else {
			CookieData = (ButtonObject.value == Item + "\Ȃ") ? CookieData | Type : CookieData & (Type ^ -1);
		}
		SetCookie2("exp",30,"/loe/",CookieData);
	}
	ButtonObject.value = ((CookieData & Type) == 0) ? Item + "\Ȃ" : Item + "\";
	DisplayType = (ButtonObject.value == Item + "\Ȃ") ? "" : "none";
	if (Max > 0) {
		for (var i = 1; i <= Max; i++) {
			ItemObject = document.getElementById(IdName + i);
			if (ItemObject) {
				ItemObject.style.display = DisplayType;
			}
		}
	}
	else {
		IdNo = 1;
		while (1) {
			ItemObject = document.getElementById(IdName + IdNo++);
			if (ItemObject) {
				ItemObject.style.display = DisplayType;
			}
			else {
				break;
			}
		}
	}
}
function SetCookie2(Name, Day, Path, Data) {
	var Exp = new Date();
	Exp.setTime(Exp.getTime() + (Day * 24 * 60 * 60 * 1000));
	document.cookie = "@" + Name + "=" + escape(Data) + "; expires=" + Exp.toGMTString() + "; path=" + Path;
}
function GetCookie2(Name) {
	var String = document.cookie + ";";
	var Cookie = "@" + Name + "=";
	var Pointer = String.indexOf(Cookie);
	if (Pointer == -1) return false;
	var Start = Pointer + Cookie.length;
	var End = String.indexOf(";", Start);
	return unescape(String.substring(Start, End));
}
